<script setup lang="ts">
import { Bar } from 'vue-chartjs'
import { ref, watch } from 'vue'
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js'

const props = defineProps({
  name: {
    type: String,
    required: true
  },
  labels: {
    type: Array,
    required: true
  },
  data: {
    type: Array<number>,
    required: true
  }
})

ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

const chartOptions = ref({
  responsive: true,
  plugins: {
    title: {
      display: true,
      text: props.name
    },
    legend: {
      display: false
    }
  },
  scales: {
    x: {
      ticks: {
        display: false //this will remove only the label
      }
    }
  },
  animation: {
    duration: 0 // general animation time
  }
})
</script>

<template>
  <div id="chart">
    <Bar
      id="my-chart-id"
      :options="chartOptions"
      :data="{
        labels: labels,
        datasets: [{ backgroundColor: '#9BD0F5', data: data }]
      }"
    />
  </div>
</template>

<style lang="scss" scoped>
#chart {
  height: 20rem;
}
</style>
